<script setup lang="ts">
import { reactive, ref } from 'vue'
import { useVuelidate } from '@vuelidate/core'
import { required } from '@vuelidate/validators'
import MsnApiV1 from '@/api/msnApi'

const props = defineProps({
  eventId: String,
  eventName: {
    type: String,
    default: '',
  },
})

const emit = defineEmits(['finished'])

const deleteEventName = ref('')
const modalOpen = ref(false)

const state = reactive({
  isError: false,
  errorMessage: '',
})

const rules = {
  deleteEventName: { required },
}

const v$ = useVuelidate(rules, { deleteEventName })

async function handleOk() {
  await v$.value.$validate()
  if (!v$.value.$error) {
    if (props.eventName !== deleteEventName.value) {
      state.isError = true
      state.errorMessage = `To delete the event the eventName must be equal to ${props.eventName}`

      return
    }
    await deleteEvent()
  }
}

async function deleteEvent() {
  try {
    const response = await new MsnApiV1().deleteEvent(props.eventId)

    emit('finished')
  }
  catch (error) {
    console.error('Error deleting event:', error)
    state.isError = true
    state.errorMessage = error.response.data.message
  }
}

function resetModal() {
  deleteEventName.value = ''
  state.isError = false
  modalOpen.value = false
}

function toggleModal() {
  modalOpen.value = !modalOpen.value
}
</script>

<template>
  <div>
    <!-- button -->
    <VBtn
      :id="`toggle-btn-${props.eventId}`"
      variant="outlined"
      color="error"
      @click="toggleModal"
    >
      <VIcon
        size="22"
        icon="tabler-trash"
        style="opacity: 1;"
      />
    </VBtn>
  </div>
</template>

<style scoped>

</style>
